<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Data' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Données
      </span>
    </div>
    <div>
      <div class="top">
        <b-row>
          <b-col class="left-col">
            <span>
              <img
                src="@/assets/icons/files_ressources.svg"
                alt="Icône ressources"
              />
              {{ resourcesList.length }} ressource{{ resourcesList.length > 1 ? 's' : '' }}
            </span>
            <div
              class="add-btn"
              @click="$router.push({ name: 'AddResource' })"
            >
              <b-icon-plus />
              Nouvelle ressource
            </div>
          </b-col>
          <b-col class="right-col">

          </b-col>
        </b-row>
      </div>
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        style="min-height: 30em;"
      >
        <div class="custom-table">
          <CustomTable
            :routeTo="'ResourceDetail'"
            :fields="fields"
            :items="items"
            :sortFunction="GET_RESOURCES_LIST"
            :selectable="false"
            @sorted="setTableSorted"
            @delete="openDeleteModal"
            @loading="setTableLoader"
          />
          <Pagination
            v-if="resourcesList.length > 0 && Math.ceil(resourcesList.length/50) > 1"
            :nbPages="Math.ceil(resourcesList.length/50)"
            @change-page="changeTablePage"
          />
        </div>
      </b-overlay>
    </div>
    <DeleteResource
      :open="deletingResource"
      :resource="resourceToDelete"
      @hide="deletingResource = false"
      @update="updateResourcesList"
    />
  </div>
</template>

<script>
import CustomTable from '@/components/CustomTable.vue';
import Pagination from '@/components/Pagination.vue';
import DeleteResource from '@/components/Modals/DeleteResource.vue';

import { mapState, mapActions } from 'vuex';

export default {
  name: 'Datasets',

  components: {
    CustomTable,
    Pagination,
    DeleteResource
  },

  data() {
    return {
      loading: false,
      fields: [
        {
          key: 'Nom',
          apiName: 'display_name',
          sortable: true,
          width: '15%',
          centered: false
        },
        {
          key: 'Organisation',
          sortable: false,
          width: '15%',
          centered: false
        },
        {
          key: 'Date de création',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Date de dernière révision',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Data rattaché',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Ressource principale',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Nombres d\'annexes',
          sortable: false,
          width: '',
          centered: true
        },
        {
          key: 'Supprimer',
          sortable: false,
          width: '8%',
          centered: true
        }
      ],
      tableSorted: {
        direction: null,
        field: null
      },
      deletingResource: false,
      resourceToDelete: null
    };
  },

  computed: {
    ...mapState('resources', ['resourcesList']),
    items() {
      return this.resourcesList.map(el => {
        return {
          id: el.id,
          'Nom': el.display_name,
          'Organisation': el.usergroup.display_name,
          'Date de création': new Date(el.creation_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Date de dernière révision': new Date(el.last_revision_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Data rattaché': '',
          'Ressource principale': '',
          'Nombres d\'annexes': ''
        }
      });
    }
  },

  created() {
    if (this.resourcesList.length === 0) {
      this.getData();
    }
  },

  methods: {
    ...mapActions('resources', ['GET_RESOURCES_LIST']),

    getData() {
      this.loading = true;
      this.GET_RESOURCES_LIST({...this.tableSorted})
      .then(() => {
        this.loading = false;
      });
    },

    changeTablePage(e) {
      this.loading = true;
      this.GET_RESOURCES_LIST({...this.tableSorted, page: e}).then(() => {
        this.loading = false;
      });
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    },

    openDeleteModal(e) {
      this.deletingResource = true;
      this.resourceToDelete = e;
    },

    updateResourcesList() {
      this.getData();
    },
  }
}
</script>
